<?php

declare(strict_types=1);

/*
 * Chill is a software for social workers
 *
 * For the full copyright and license information, please view
 * the LICENSE file that was distributed with this source code.
 */

namespace Chill\PersonBundle\PersonIdentifier\Identifier;

use Chill\PersonBundle\Entity\Identifier\PersonIdentifier;
use Chill\PersonBundle\Entity\Identifier\PersonIdentifierDefinition;
use Chill\PersonBundle\PersonIdentifier\PersonIdentifierEngineInterface;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;

final readonly class StringIdentifier implements PersonIdentifierEngineInterface
{
    public static function getName(): string
    {
        return 'chill-person-bundle.string-identifier';
    }

    public function canonicalizeValue(array $value, PersonIdentifierDefinition $definition): ?string
    {
        return $value['content'] ?? '';
    }

    public function buildForm(FormBuilderInterface $builder, PersonIdentifierDefinition $personIdentifierDefinition): void
    {
        $builder->add('content', TextType::class, ['label' => false]);
    }

    public function renderAsString(?PersonIdentifier $identifier, PersonIdentifierDefinition $definition): string
    {
        return $identifier?->getValue()['content'] ?? '';
    }
}
